/*
 * hexdump.c
 * Russ Clark, I didn't write it, not sure who did.
 *
 * Anybody writing network code needs to have this handy.
 * It does a hexidecimal dump of n bytes starting at location a.
 *
 * char *a; starting address
 * int n;   number of bytes to dump
 */

hexdump(a,n)
char *a;
int n;
{
   int i,j;
   printf("       %d bytes\n", n );

   for ( j=0; j<n; j+=16 ) {
        printf("%03x: ", j );
        for ( i=j; i<j+16; i++ ) {
            if ( i<n ) {
                printf("%02x ", a[i]&255 );
            } else {
                printf("   ");
            }
        }
        printf("   ");
        for ( i=j; i<j+16; i++ ) {
            if ( i<n )
                putchar ( 32<=(a[i]&127) && (a[i]&127)<127 ? a[i]&127 : '.' );
            else
                putchar ( ' ' );
        }
        putchar('\n');
    } /* next j */
}

