
/*
 * File: nwsim.h
 * Author: Russell J Clark
 * Date: September 20, 1995
 * 
 * This is the common header file for the network simulator components.
 * It defines port numbers and other constants including the packet
 * sizes used.
 *
 * The total size of the data sent through the simulator is the sum
 * of PACKET_DATA_SIZE and PACKET_TRAILER_SIZE. 
 *
 */

#define PACKET_DATA_SIZE	1024
#define PACKET_TRAILER_SIZE	1
#define PACKET_TOTAL_SIZE 	PACKET_DATA_SIZE + PACKET_TRAILER_SIZE



